﻿using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApplication9
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.CreateData();
            this.ultraGrid1.DisplayLayout.PerformAutoResizeColumns(false, PerformAutoSizeType.AllRowsInBand);
        }

        private void CreateData()
        {
            for (int companyNum = 1; companyNum < 5; companyNum++)
            {
                string company = string.Format("Comp{0}", companyNum);
                string id = string.Format("CC{0}C", companyNum);
                int col1 = 89999 + companyNum;

                int rowCount = DummyDataCreator.RandomInt(1, 5);
                for (int row = 1; row < rowCount; row++)
                {
                    string col2 = string.Format("ASDF{0}", row);
                    int col3 = DummyDataCreator.RandomInt(1, 10) * 5;
                    int col4 = DummyDataCreator.RandomInt(1, 10);

                    this.ultraDataSource1.Rows.Add(new object[] { company, id, col1, col2, col3, col4,1});
                }
            }
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            var layout = e.Layout;
            var band = layout.Bands[0];
            var ov = layout.Override;

            // In order to provide a summary for each company, you need to group by the company.
            var companyColumn = band.Columns["Company"];
            layout.ViewStyleBand = ViewStyleBand.OutlookGroupBy;
            band.SortedColumns.Add(companyColumn, false, true);

            //Add a summary for the id column,
            //it should be count summary and will be used to display the total on the same row
            //by overriding its display format
            var columnID = band.Columns["ID"];
            band.Summaries.Add(SummaryType.Count, columnID);

            // Add a summary for column 3.
            var column3 = band.Columns["Col3"];
            band.Summaries.Add(SummaryType.Sum, column3);

            // Add a summary for column 4.
            var column4 = band.Columns["Col4"];
            band.Summaries.Add(SummaryType.Sum, column4);

            ov.SummaryDisplayArea =
                SummaryDisplayAreas.InGroupByRows | // This will give us summaries in the GroupByRow itself
                SummaryDisplayAreas.BottomFixed | // This will give us a grand total at the bottom. 
                SummaryDisplayAreas.GroupByRowsFooter // This will give us a summary under each GroupByRow
                ;

            // Make the summaries in the GroupByRow appears as cells instead of just raw text. 
            ov.GroupBySummaryDisplayStyle = GroupBySummaryDisplayStyle.SummaryCells;

            //Hide the footer caption of the summaries
            ov.SummaryFooterCaptionVisible = Infragistics.Win.DefaultableBoolean.False;
            band.Summaries[0].DisplayFormat = "Total";
            band.Summaries[0].Appearance.BackColor = Color.Transparent;
        }
    }
}
